<link rel="import" href="/extern/bower_components/paper-button/paper-button.html">
<link rel="import" href="/extern/bower_components/paper-slider/paper-slider.html">
<link rel="import" href="/extern/bower_components/iron-icon/iron-icon.html">
<link rel="import" href="/extern/bower_components/iron-icons/iron-icons.html">
<link rel="import" href="/ts/common-elements/relative-time/relative-time.html">
<link rel="import" href="/ts/common-elements/reset-css/reset-css.html">
<link rel="import" href="/ts/common-elements/iron-flex-layout-attributes/iron-flex-layout-attributes.html">
<link rel="import" href="/ts/ajaxell/html/elements/ag-toaster/throws-toast.html">

<!--

`auto-update` automatically updates server-side data for you.

Note that it is very similar to [`ts-ajax`](../ts-ajax/index.html). However
[`ts-ajax`](../ts-ajax/index.html) only makes a request when you ask for it,
`auto-update` implements an interval with which it will automatically and
periodically make a request.

Example html in your panel:

    <auto-update data="{{my_variable}}" callback="cpp_callback" handle-as="text"></auto-update>
    <span>{{my_variable}}</span>

Example C++ code:

    void PanelExample::layout(cgicc::Cgicc& cgi)
    {
      setEvent("cpp_callback", ajax::Eventable::OnTime, this, &PanelExample::updatesomedata);
      add(new ajax::PolymerElement("my-panel"));
    }
    void PanelExample::updatesomedata(cgicc::Cgicc& cgi,std::ostream& out)
    {
      static int times(0);
      times++;
    	std::ostringstream msg;
    	msg << "The PanelExample::updatesomedata method has been executed " << times << " times";
    	out << msg.str();
    }

Example html with parameters:

    <paper-input value="{{favDino}}" label="your favorite dinosaur"></paper-input>
    <auto-update data="{{test2}}"
                 interval="1000"
                 callback="parametersexample"
                 handle-as="text"
                 parameters='["favoritedino"]'
                 favoritedino="{{favDino}}"
                 ></auto-update>
                 notice the single & double quotes in the parameters variable
                 do yourself a favor and do not use capital letters in parameter names
    <span>{{test2}}</span>

Example C++ with parameters:

    void PanelExample::withparametersexample(cgicc::Cgicc& cgi,std::ostream& out)
    {
    	std::ostringstream msg;

    	std::map<std::string,std::string> values(ajax::toolbox::getSubmittedValues(cgi));

    	msg << "Your favorite dinosaur is the ";

    	for(std::map<std::string,std::string>::iterator i(values.begin()); i != values.end(); ++i) {
    			if ( i->first.compare("favoritedino") == 0 ) {
    				msg << i->second;
    			}
    	}

    	out << msg.str();
    }
    void PanelExample::layout(cgicc::Cgicc& cgi)
    {
      setEvent("parametersexample", ajax::Eventable::OnTime, this, &PanelExample::withparametersexample);
      add(new ajax::PolymerElement("my-panel"));
    }

-->

<dom-module id="auto-update">
  <template>
    <link rel="import" type="css" href="css/auto-update-min.css?__inline=true">
    <style include="reset-css"></style>
    <style include="iron-flex-layout-attributes"></style>
    <iron-ajax id="ajax" method="post" on-response="_onResponse" on-error="_onError"></iron-ajax>

    <div horizontal layout id="guicontainer" hide$="{{headless}}">

      <paper-button raised on-click="manualRefresh" disabled="{{noRefresh}}">
          <iron-icon icon="refresh"></iron-icon>
          <div progress>
            <div id="progressbar"></div>
          </div>
      </paper-button>

      <div vertical layout hide$="{{noSlider}}" flex>
        <div horizontal layout>
          <span hide$="{{!noRefresh}}">(disabled)</span>
          <span disabled$="{{noRefresh}}">T = <span>{{interval}}</span>ms</span>
          <span disabled$="{{noRefresh}}">last: <relative-time date="{{lastUpdated}}" precise></relative-time></span>
        </div>
        <paper-slider max-markers="100" min="0" max="10000" step="1000" value="{{interval}}" pin snaps disabled="{{noRefresh}}"></paper-slider>
      </div>

    </div>

  </template>
</dom-module>
<script src="javascript/auto-update-min.js?__inline=true"></script>
